' url2htm.VBS 1.00 (C) yoshioka.teruo@nifty.com 2004-11-28
' url2htm.VBS decodes encoded URLs text file to Shift JIS html file.
' Usage: CScript //NoLogo url2htm.VBS <url.txt >sjis.htm

Option Explicit
Dim stdin
Dim stdout
Dim line
Dim error
Dim fileProtocol

Set stdin=WScript.StdIn
Set stdout=WScript.StdOut

stdout.WriteLine "<html>"
Do While Not stdin.AtEndOfStream
  line=Trim(stdin.ReadLine)
  stdout.WriteLine "<a href=""" & line & """>"
  stdout.WriteLine decodeURL(line)
  stdout.WriteLine "</a><br>"
Loop
stdout.WriteLine "</html>"

Function decodeURL(url)
Dim sjis
Dim re

Set re=New RegExp
re.IgnoreCase=True
re.Pattern="UTF-8|EUC|SHIFT_JIS"

fileProtocol=InStr(UCase(url),"file:")
sjis=""
If re.Test(url) Then
Select Case UCase(re.Execute(url)(0).Value)
Case "EUC" sjis=decodeEUC(url)
Case "UTF-8" sjis=decodeUTF8(url)
Case "SHIFT_JIS" sjis=decodeSJIS(url)
End Select
End If
If sjis="" Then sjis=decodeEUC(url)
If sjis="" Then sjis=decodeSJIS(url)
If sjis="" Then sjis=decodeUTF8(url)
If sjis="" Then sjis=error
decodeURL=sjis
End Function

Function decodeSJIS(ByVal src)
Dim dst,k,char,asc1,asc2
src=UnEscape(src)
For k=1 To Len(src)
  char=Mid(src,k,1)
  Asc1=AscW(char)
  If fileProtocol Then If Asc1=43 Then Asc1=32
  If (&H00 <= Asc1 And Asc1 <= &H80) Or _
     (&HA0 <= Asc1 And Asc1 <= &HDF) Then
    char=Chr(Asc1)
  ElseIf (&H81 <= Asc1 And Asc1 <= &H9F) Or _
         (&HE0 <= Asc1 And Asc1 <= &HFF) Then
    k=k + 1
    char=Mid(src,k,1)
    Asc2=AscW(char)
    If Asc2<64 Or Asc2>252 Then
      error="Invalid SJIS second byte : " & Right(Hex(Asc2+256),2)
      Exit Function
    End If
    char=Asc1*256+Asc2
    If (Asc(chr(char)) And &HFFFF&)=char Then
       char=Chr(char)
    Else
      char="%s" & Right(Hex(char+256*256),4)
      error="Invalid SJIS code : " & char
      Exit Function
    End If
  Else
    error="Invalid SJIS first byte : " & Right(Hex(Asc1+256),2)
    Exit Function
  End If
  dst=dst & char
Next
decodeSJIS=dst
End Function

Function decodeEUC(ByVal buf)
Dim code
Dim code1
Dim code2
Dim k
Dim euc

buf=UnEscape(buf)
For k=1 To Len(buf)
  code=AscW(Mid(buf,k,1))
  If fileProtocol Then If code=43 Then code=32
  If code<&H80 Then
    euc=euc & Chr(code)
  ElseIf code=&H8E Then
    k=k+1
    code=AscW(Mid(buf,k,1))
    euc=euc & Chr(code)
  Else
    code1=code
    k=k+1
    code2=AscW(Mid(buf,k,1))
    code=jis2sjis((code1 And &H7F) * 256 + (code2 And &H7F))
    If code Then
      euc=euc & Chr(code)
    Else
      euc=euc & "%" & Right(Hex(code1+256),2) & "%" & Right(Hex(code2+256),2)
      error="Invalid EUC code : " & Right(Hex(code1+256),2) & Right(Hex(code2+256),2)
      Exit Function
    End If
  End If
Next
decodeEUC=euc
End Function

Function jis2sjis(j)
Dim s
Dim a
Dim b

a=j \ 256
b=j mod 256
If 33<=a And a<= 94 Then
  If a mod 2 Then
    If 33<=b And b<= 95 Then
      s=a*128+b+28831
    ElseIf 96<=b And b<=126 Then
      s=a*128+b+28832
    Else
      s=0
    End if
  Else
    If 33<=b And b<=126 Then
      s=a*128+b+28798
    Else
      s=0
    End If
  End If
ElseIf 95<=a And a<=126 Then
  If a mod 2 Then
    If 33<=b And b<= 95 Then
      s=a*128+b+45215
    ElseIf 96<=b And b<=126 Then
      s=a*128+b+45216
    Else
      s=0
    End If
  ElseIf 33<=b And b<=126 Then
    s=a*128+b+45182
  Else
    s=0
  End If
Else
  s=0
End If
If s=0 Then
  error="Invalid JIS Code : " & Right(Hex(a+256),2) & Right(Hex(b+256),2)
End If
jis2sjis=s
End Function

Function decodeUTF8(ByVal buf)
Dim code
Dim code1
Dim code2
Dim code3
Dim k
Dim sjis

buf=UnEscape(buf)
For k=1 To Len(buf)
  code=AscW(Mid(buf,k,1))
  If fileProtocol Then If code=43 Then code=32
  If 0<=code And code<128 Then
    sjis=sjis & ChrW(code)
  ElseIf 128+64<=code And code<128+64+32 Then
    code1=code
    k=k+1
    code2=AscW(Mid(buf,k,1))
    code=(code1 And &H1F) * 64 + (code2 And &H3F)
    If Chr(Asc(ChrW(code)))=ChrW(code) Then
      sjis=sjis & ChrW(code)
    Else
      sjis=sjis & Escape(ChrW(code))
      error="Invalid UTF-8 Code : " & Escape(ChrW(code)) & " " & Right(Hex(code1+256),2) & Right(Hex(code2+256),2)
    End If
  ElseIf 128+64+32<=code And code<128+64+32+16 Then
    code1=code
    k=k+1
    code2=AscW(Mid(buf,k,1))
    k=k+1
    code3=AscW(Mid(buf,k,1))
    code=(code1 And &H0F) * 16 * 256 + (code2 And &H3F) * 64 + (code3 And &H3F)
    If Chr(Asc(ChrW(code)))=ChrW(code) Then
      sjis=sjis & ChrW(code)
    Else
      sjis=sjis & Escape(ChrW(code))
      error="Invalid UTF-8 Code : " & Escape(ChrW(code)) & " " & Right(Hex(code1+256),2) & Right(Hex(code2+256),2) & Right(Hex(code3+256),2)
    End If
  Else
    sjis=sjis & Escape(ChrW(code))
    error="Invalid UTF-8 Code : " & Escape(ChrW(code)) & " " & Right(Hex(code+256),2)
  End If
Next
decodeUTF8=sjis
End Function
